import com.gc.android.market.api.MarketSession;
import com.gc.android.market.api.MarketSession.Callback;
import com.gc.android.market.api.model.Market.CommentsRequest;
import com.gc.android.market.api.model.Market.CommentsResponse;
import com.gc.android.market.api.model.Market.ResponseContext;
import java.util.*;
import java.text.*;

public class getAppComments {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO ꂽ\bhEX^u

		if(args.length < 5) {
			System.out.println("Usage :\n" +
					"java -jar this_jar_name email password appid startIndex numbers [androidId]");
			return;
		}

		String email = args[0];
		String password = args[1];
		String appid = args[2];
		final int startIndex = Integer.parseInt(args[3]);
		final int numbers = Integer.parseInt(args[4]);
		String androidid = args.length > 5 ? args[5] : "0123012301230123";
		
		MarketSession session = new MarketSession();
		session.getContext().setAndroidId(androidid);
		Locale locale = new Locale("ja","JP");
		session.setLocale(locale);

		try
		{
			session.login(email,password);
		} catch (Exception e) {
			System.out.println("Login Failed: " + e.getMessage());
			System.exit(1);
		}
		
		CommentsRequest commentsRequest = CommentsRequest.newBuilder()
									.setAppId(appid)
									.setStartIndex(startIndex)
									.setEntriesCount(numbers)
									.build(); 

		Callback<CommentsResponse> callback = new Callback<CommentsResponse> () {

				@Override
				public void onResult(ResponseContext context, CommentsResponse response) {
					// TODO ꂽ\bhEX^u
					int totalcnt,cnt;
					if(response != null) {
						totalcnt = response.getEntriesCount();
						cnt = response.getCommentsCount();
//						System.out.println(cnt);
					} else {
						cnt = -1; 
//						System.out.println(cnt);
					}
					if (cnt > 0) {
						for(int i = 0; ((i < cnt) && (i < numbers)); i++) {
							int counter = i + startIndex + 1;
							System.out.print(counter + ",");
							System.out.print("\"" + response.getComments(i).getAuthorName() + "\",");
							System.out.print(convTime(response.getComments(i).getCreationTime()) + ",");
							System.out.print(response.getComments(i).getRating() + ",");
							System.out.print("\"" + response.getComments(i).getText() + "\",");
							System.out.print("\"" + response.getComments(i).getAuthorId() + "\",");
							System.out.print("\n");
						}
					} else if (cnt == 0) {
						System.out.println("no hit");
					} else {
						System.out.println("Bad Reqeust");
					}
					
				}

				private String convTime(long creationTime) {
					// TODO ꂽ\bhEX^u
			        Date date = new Date(creationTime);
			        DateFormat df =
			            new SimpleDateFormat("\"yyyy/MM/dd\",\"EE\",\"HH:mm:ss\",\"zz\"");
			        return df.format(date);
				}
		};
		session.append(commentsRequest, callback);
		session.flush();
	}
}
